mode(-1);

/////////////////////////////////////////////////////////////////////////////
//
// Simulazione roulette
// Copyright (C) 2000 Bellotti Stefano <signo@lugbs.linux.it>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
/////////////////////////////////////////////////////////////////////////////

getf("funroul.sci");

ystr=[ 'Soldi iniziali';
       'Numero di risultati dello stesso colore prima di puntare';
       'Lunghezza della partita (in giri roulette)';
       'Numero partite';
       'Massima perdita per abbandonare';
       'Minimo guadagno per abbandonare' ];
w=x_mdialog('Scegli i parametri per simulazione roulette',...
  ystr,['50';'3';'200';'1000';'50';'10'])

if w~=[] then

 s0=int(evstr(w(1)));
 nc=int(evstr(w(2)));
 n=int(evstr(w(3)));
 ntot=int(evstr(w(4)));
 maxloose=int(evstr(w(5)));
 minwin=int(evstr(w(6)));

 mprintf('Simulazione roulette - Versione 1.00\n\n');
 mprintf('Soldi iniziali = %d\n',s0);
 mprintf('Strategia di gioco:\n')
 mprintf('Dopo %d volte consecutive che esce un colore punto\n',nc);
 mprintf('sull''altro colore, se non vinco continuo a puntare\n');
 mprintf('su quel colore raddoppiando la puntata\n');
 mprintf('\nSimulazione di %d scommesse in corso...\n',n);
 v=soldi(s0,nc,n);
 xbasc(0);
 xselect();
 plot2d(v);
 xtitle('Simulazione roulette - singola partita','Tempo','Soldi');
 mprintf('\nPremi un tasto per continuare...\n');
 halt();
 mprintf('\nCalcolo della media su %d simulazioni...\n',ntot);
 mprintf('\n(Tempo stimato: %d minuti e %d secondi su un k6 200)\n',int(0.11*n/100*ntot/60),modulo(0.11*n/100*ntot,60));
 v=soldi(s0,nc,n);
 bancarotta=0;
 guadbanc=0;
 successo=0;
 guadsucc=0;
 guad=0;

 for i=1:ntot
  v1=soldi(s0,nc,n);
  for j=1:n
   if v1(j)<=s0-maxloose then
    //ho perso
    bancarotta=bancarotta+1;
    guadbanc=guadbanc+v1(j)-s0;
    break;
   end
   if v1(j)>=s0+minwin then
    //ho vinto
    successo=successo+1;
    guadsucc=guadsucc+v1(j)-s0;
    break;
   end
   if j==n then
    //mi sono stufato
    guad=guad+v1(j)-s0;
   end
  end
  v=v+v1;
 end
 v=v/ntot;
 xbasc(0);
 xselect();
 plot2d(v);
 xtitle('Simulazione roulette - media su piu'' partite','Tempo','Soldi');
 mprintf('\nSmetto di giocare se:\n');
 mprintf('- Perdo %d\n',maxloose);
 mprintf('- Guadagno %d\n',minwin);
 mprintf('- Ho gia fatto %d scommesse\n',n);
 mprintf('\nSu %d partite ho realizzato:\n',ntot);
 mprintf('%d volte bancarotta (%0.1f%%), e ho perso %d\n',bancarotta,bancarotta*100/ntot,-guadbanc);
 mprintf('%d volte successo (%0.1f%%), e ho guadagnato %d\n',successo,successo*100/ntot,guadsucc);
 mprintf('%d volte mi sono stufato, e ho guadagnato %d\n', ntot-bancarotta-successo, guad);
 mprintf('\nIn totale ho guadagnato %d\n',guadbanc+guadsucc+guad);
 mprintf('\nPremi un tasto per continuare...\n');
 halt();

 mprintf('\nAndamento del guadagno in funzione di min vincita e max perdita\n',ntot);
 mprintf('\n(Tempo stimato: %d minuti e %d secondi su un k6 200)\n',int(0.11*n/100*ntot*10*10/60),modulo(0.11*n/100*ntot*10*10,60));

 guad=zeros(10,10);

 for l=1:10
  for w=1:10
   //guad(l,w)=0
   for i=1:ntot
    v1=soldi(s0,nc,n);
    for j=1:n
     if v1(j)<=s0-(l-1)*(maxloose/9) | v1(j)>=s0+(w-1)*(minwin/9) | j==n then
      //fine gioco
      guad(l,w)=guad(l,w)+v1(j)-s0;
      break;
     end
    end
   end
  end
 end

 //Puo' essere utile salvare...
 //save('guad.dat',guad);

 xbasc(0);
 xselect();
 plot3d(0:maxloose/9:maxloose,0:minwin/9:minwin,guad);
 xtitle('Simulazione roulette - guadagno in funzione di massima perdita e minima vincita');

end
